# m4 = torch.load("models/fc(4)-GELU")
# sorted([torch.mean(p).item() for p in m.parameters()])[len(list(m.parameters()))//2]
# sorted([torch.std(p).item() for p in m.parameters()])[len(list(m.parameters()))//2]

import torch
import numpy as np

# def info(path):
# 	m = torch.load(f"models/{path}")
# 	μs=sorted([torch.mean(p).item() for p in m.parameters()])
# 	σs=sorted([torch.std(p).item() for p in m.parameters()])
# 	mμ=μs[len(μs)//2]
# 	mσ=σs[len(μs)//2]
# 	aμ=np.mean(μs)
# 	aσ=np.mean(σs)
# 	print(f"[μ,σ] | median=[{mμ:.4f},{mσ:.4f}] | avg=[{aμ:.4f},{aσ:.4f}]")


# info("fc(2)-GELU")
# info("fc(4)-GELU")
# info("fc(8)-GELU")
# info("fc(16)-GELU")


def info(path):
	m = torch.load(f"models/{path}")
	θs = sum([torch.flatten(p).cpu().detach().tolist() for p in m.parameters()],[])
	plt.figure(figsize=(6.4,2))
	plt.clf()
	plt.hist(θs,256,density=True)
	plt.tight_layout()
	plt.xlim([-4, 4])
	# plt.yscale('log')
	plt.savefig(f"out/{path}-θ_hist.png")
	plt.yscale('log')
	plt.savefig(f"out/{path}-θ_hist-log.png")
	μ=np.mean(θs)
	σ=np.std(θs)
	print(f"[μ,σ]=[{μ:.4f},{σ:.4f}]")


info("fc(2)-GELU")
info("fc(4)-GELU")
info("fc(8)-GELU")
info("fc(16)-GELU")

info("fc(2)-Sin")
info("fc(4)-Sin")
info("fc(8)-Sin")
info("fc(16)-Sin")

